﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace InterceptBackspace {
    public partial class MainForm : Medo.Windows.Forms.WndProcForm {
        public MainForm() {
            InitializeComponent();
        }

        protected override void WndProc(IntPtr hWnd, int msg, IntPtr wParam, IntPtr lParam) {
            if (msg == NativeMethods.WM_HOTKEY) {
                int hiWord = (short)(((uint)lParam.ToInt32() & 0xFFFF0000U) >> 16);
                int loWord = (short)((uint)lParam.ToInt32() & 0x0000FFFFU);
                if ((hiWord == NativeMethods.VK_TBACK) && ((loWord & NativeMethods.MOD_KEYUP) != 0)) {
                    lblInfo.Text = string.Format("Tab key detected at {0}.", DateTime.Now.TimeOfDay);
                    return; //or omit this if you still want default behaviour.
                }
            }
            base.WndProc(hWnd, msg, wParam, lParam);
        }


        private static class NativeMethods {

            internal const int WM_HOTKEY = 0x0312;
            internal const int MOD_KEYUP = 0x1000;
            internal const int VK_ESCAPE = 0x1B;
            internal const int VK_TBACK = VK_ESCAPE;

        }

    }
}